#!/usr/bin/perl -w
# cleanup GRASSLinks temp files not modified last xx hours
# run by root or user with write permissions for webuser
# suggest run as cronjob every xx hours or daily
# for example in roots crontab:
#04 06 * * * cd /home/httpd/html/glinks/progs; ./clean_tmp.pl | mail -s "Glinks cleanup" coopl
# replaces glinks31 cleanup programs clean_tmp and checktimes.c
# modify/use at your own risk
#
my $oldest = 0.25; # oldest age in days ex 0.25=6 hrs

# MODIFY HERE full list of temp directories used by GRASSLinks
my @dirs = ( 
"/home/httpd/html/glinks/tmp/",
"/data/nw_nl/grasslinks1/.tmp/ippc2.orst.edu/",
"/data/nw_nl/grasslinks2/.tmp/ippc2.orst.edu/",
"/data/nw_nl/grasslinks3/.tmp/ippc2.orst.edu/",
"/data/nw_nl/nobody/.tmp/ippc2.orst.edu/",
"/home2/data/OR_ll/grasslinks1/.tmp/ippc2.orst.edu/",
"/home2/data/OR_ll/nobody/.tmp/ippc2.orst.edu/"
);

my $filename = "";
foreach my $dirname (@dirs) {
  opendir(DIR, $dirname) or die "cant opendir $dirname: $!";
  while (defined($filename = readdir(DIR))) {
    my $fullname =  $dirname . $filename;
    if (-f $fullname) {
      my $age = (-M $fullname);
      #print "newfile $fullname AGE is ", $age, "\n" unless $age > $oldest; 
      unlink($fullname) || warn "cant rm $fullname $!" unless $age < $oldest; 
    }
}
closedir(DIR);
}
